From 2d9f29fd05632d97710d68fceea6277d17e833ba Mon Sep 17 00:00:00 2001
From: Shaily <shaily15297@yahoo.com>
Date: Feb 05 2018 14:33:19 +0000
Subject: [PATCH 16/32] Issues: Refactoring after review


---

diff --git a/hubs/static/client/app/components/HubConfig/HubConfigPanelVCS.js b/hubs/static/client/app/components/HubConfig/HubConfigPanelVCS.js
index 6df26cf..fb7d147 100644
--- a/hubs/static/client/app/components/HubConfig/HubConfigPanelVCS.js
+++ b/hubs/static/client/app/components/HubConfig/HubConfigPanelVCS.js
@@ -58,22 +58,22 @@ export default class VCSPanel extends React.Component {
       <form onSubmit={(e) => {e.preventDefault();}}>
         <FormattedMessage {...messages.title} tagName="h3" />
         <FormattedMessage {...messages.intro} tagName="p" />
-        {["pagure_username", "github_username", "bugzilla_email"].map(function(x, i) {
+        {["pagure_username", "github_username", "bugzilla_email"].map(function(configParam) {
           return (
-            <div key={i} className="form-group row">
-              <label htmlFor={"hub-settings-vcs-" + x}>
-                <FormattedMessage {...messages[x]} />
+            <div key={configParam} className="form-group row">
+              <label htmlFor={"hub-settings-vcs-" + configParam}>
+                <FormattedMessage {...messages[configParam]} />
               </label>
               <input
                 type="text"
-                name={x}
+                name={configParam}
                 className={"form-control"}
-                id={"hub-settings-vcs-" + x}
+                id={"hub-settings-vcs-" + configParam}
                 onChange={this.handleChange}
-                value={this.props.hubConfig[x] || ""}
+                value={this.props.hubConfig[configParam] || ""}
                 />
               <p className="form-text text-muted">
-                <FormattedMessage {...messages[x + "_help"]} />
+                <FormattedMessage {...messages[configParam + "_help"]} />
               </p>
             </div>
           )
diff --git a/hubs/static/client/app/widgets/issues/Config.js b/hubs/static/client/app/widgets/issues/Config.js
index 82714f2..5ef68f8 100644
--- a/hubs/static/client/app/widgets/issues/Config.js
+++ b/hubs/static/client/app/widgets/issues/Config.js
@@ -1,52 +1,68 @@
 import React from 'react';
 import {
-    defineMessages,
-    injectIntl,
-    FormattedMessage
+  defineMessages,
+  FormattedMessage
 } from 'react-intl';
 
 
 const messages = defineMessages({
-    select_author: {
-        id: "hubs.widgets.halp.config.select.author",
-        defaultMessage: "Tickets I Filed",
-    },
-    select_assignee: {
-        id: "hubs.widgets.halp.config.select.assignee",
-        defaultMessage: "Tickets Waiting on Me",
-    },
+  select_author: {
+    id: "hubs.widgets.halp.config.select.author",
+    defaultMessage: "Tickets I Filed",
+  },
+  select_assignee: {
+    id: "hubs.widgets.halp.config.select.assignee",
+    defaultMessage: "Tickets Waiting on Me",
+  },
 });
 
 
 class Config extends React.Component {
 
-    constructor(props) {
-        super(props);
-        this.handleModeChanged = this.handleModeChanged.bind(this);
-    }
-
-    handleModeChanged(e) {
-        this.props.setConfig("mode", e.target.value);
-    }
-
-    render() {
-        return (
-            <div className="form-group">
-                <label>Mode</label>
-                <select className="form-control"
-                        value={this.props.values.mode}
-                        onChange={this.handleModeChanged}>
-                    <option value="author">
-                        <FormattedMessage {...messages.select_author} />
-                    </option>
-                    <option value="assignee">
-                        <FormattedMessage {...messages.select_assignee} />
-                    </option>
-                </select>
-            </div>
-        );
-    }
+  constructor(props) {
+    super(props);
+    this.handleModeChanged = this.handleModeChanged.bind(this);
+    this.handleCountChanged = this.handleCountChanged.bind(this);
+  }
+
+  handleModeChanged(e) {
+    let mode = e.target.value;
+    this.props.setConfig("mode", mode);
+  }
+
+  handleCountChanged(e) {
+    let count = e.target.value;
+    this.props.setConfig("count", count);
+  }
+
+  render() {
+    return (
+      <div>
+        <div className="form-group">
+          <label>Mode</label>
+          <select className="form-control"
+                  value={this.props.values.mode}
+                  onChange={this.handleModeChanged}>
+            <option value="author">
+              <FormattedMessage {...messages.select_author} />
+            </option>
+            <option value="assignee">
+              <FormattedMessage {...messages.select_assignee} />
+            </option>
+          </select>
+        </div>
+        <div className="form-group">
+          <label>Count</label>
+          <input type="number"
+                 className="form-control"
+                 value={this.props.values.count}
+                 onChange={this.handleCountChanged}
+          />
+        </div>
+      </div>
+    );
+  }
 }
 
 
-export default injectIntl(Config);
+export default Config;
diff --git a/hubs/static/client/app/widgets/issues/Footer.js b/hubs/static/client/app/widgets/issues/Footer.js
new file mode 100644
index 0000000..258bd00
--- /dev/null
+++ b/hubs/static/client/app/widgets/issues/Footer.js
@@ -0,0 +1,64 @@
+import React from 'react';
+import PropTypes from "prop-types";
+
+
+export default class Footer extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      expanded: false
+    };
+    this.toggleCounts = this.toggleCounts.bind(this);
+  }
+
+  toggleCounts() {
+    this.setState({
+      expanded: !this.state.expanded
+    });
+  }
+
+  render() {
+    return (
+      <div className="card-footer p-1">
+        <div className="row p-1">
+          <div className="col-md-3 text-muted" style={{cursor: 'pointer'}} onClick={this.toggleCounts}>
+            <span>View More</span>
+            <i className="fa fa-angle-right ml-1" aria-hidden="true"/>
+          </div>
+          {this.state.expanded &&
+          <div className="col-md-9">
+            <div className="row pt-0">
+              {this.props.counts.bugzilla &&
+              <div className="col-md-4 text-center">
+                <img src="https://bugzilla.redhat.com/favicon.ico" style={{height: '16px'}} className={"mr-2"}/>
+                <a target="blank"
+                   href={this.props.counts.bugzilla.link}>Bugzilla ({this.props.counts.bugzilla.count})</a>
+              </div>
+              }
+              {this.props.counts.github &&
+              <div className="col-md-4 text-center">
+                <img src="https://github.com/favicon.ico" style={{height: '16px'}} className={"mr-2"}/>
+                <a target="blank"
+                   href={this.props.counts.github.link}>Github ({this.props.counts.github.count})</a>
+              </div>
+              }
+              {this.props.counts.pagure &&
+              <div className="col-md-4 text-center">
+                <img src="https://pagure.io/static/favicon.ico" style={{height: '16px'}} className={"mr-2"}/>
+                <a target="blank"
+                   href={this.props.counts.pagure.link}>Pagure ({this.props.counts.pagure.count})</a>
+              </div>
+              }
+            </div>
+
+          </div>
+          }
+        </div>
+      </div>
+    )
+  }
+}
+Footer.propTypes = {
+  counts: PropTypes.object.isRequired,
+};
diff --git a/hubs/static/client/app/widgets/issues/Issue.js b/hubs/static/client/app/widgets/issues/Issue.js
new file mode 100644
index 0000000..eb5094b
--- /dev/null
+++ b/hubs/static/client/app/widgets/issues/Issue.js
@@ -0,0 +1,35 @@
+import React from 'react';
+import PropTypes from "prop-types";
+
+
+export default class Issue extends React.Component {
+
+  render() {
+    return (
+      <li className="py-2">
+        <div className="row">
+          <div className="col-md-6">
+            <a href={this.props.issue.url}
+               target="_blank" rel="noopener noreferrer">
+              <span className="badge badge-primary">#{this.props.issue.number}</span>
+            </a>
+          </div>
+          <div className="col-md-6">
+            <div className="float-right">
+              <span>{this.props.issue.project}</span>
+              <img src={this.props.issue.icon} style={{height: '16px'}} className={"ml-2"}/>
+            </div>
+          </div>
+        </div>
+        <div className="row">
+          <div className="col-12">
+            <span>{this.props.issue.title}</span>
+          </div>
+        </div>
+      </li>
+    )
+  }
+}
+Issue.propTypes = {
+  issue: PropTypes.object.isRequired,
+};
diff --git a/hubs/static/client/app/widgets/issues/Widget.js b/hubs/static/client/app/widgets/issues/Widget.js
index 8daf21a..b83bab6 100644
--- a/hubs/static/client/app/widgets/issues/Widget.js
+++ b/hubs/static/client/app/widgets/issues/Widget.js
@@ -3,6 +3,8 @@ import { apiCall } from '../../core/utils';
 import WidgetChrome from '../../components/WidgetChrome';
 import PropTypes from "prop-types";
 import Spinner from "../../components/Spinner";
+import Issue from "./Issue";
+import Footer from "./Footer";
 
 
 export default class IssuesWidget extends React.PureComponent {
@@ -11,7 +13,7 @@ export default class IssuesWidget extends React.PureComponent {
     super(props);
     this.state = {
       issues: [],
-      more: {},
+      counts: {},
       error: null,
       isLoading: true
     };
@@ -28,7 +30,7 @@ export default class IssuesWidget extends React.PureComponent {
     this.setState({isLoading: true});
     apiCall(this.props.widget.urls.data).then(
       (data) => {
-        this.setState({issues: data.issues, more: data.more, isLoading: false});
+        this.setState({issues: data.issues, counts: data.counts, isLoading: false});
       },
       (error) => {
         this.setState({error: error.message, isLoading: false});
@@ -41,79 +43,28 @@ export default class IssuesWidget extends React.PureComponent {
     if (this.state.isLoading) {
       content = <Spinner className="p-3"/>
     }
+    else if (this.state.error) {
+      content = (
+        <div className="alert alert-warning m-2">
+          {this.state.error}
+        </div>
+      )
+    }
     else {
-      if (this.state.error) {
-        content = (
-          <div className="alert alert-warning m-2">
-            {this.state.error}
-          </div>
-        )
-      }
-      else {
-        content = (
-          <div>
-            <ul className="list-unstyled">
-              {
-                this.state.issues.map((issue) => {
-                  return (
-                    <li key={issue.service + issue.number} className="py-2">
-                      <div className="row">
-                        <div className="col-md-6">
-                          <a href={issue.url}
-                             target="_blank" rel="noopener noreferrer">
-                            <span className="badge badge-primary">#{issue.number}</span>
-                          </a>
-                        </div>
-                        <div className="col-md-6">
-                          <div className="float-right">
-                            <span>{issue.project}</span>
-                            <img src={issue.icon} style={{height: '16px'}} className={"ml-2"}/>
-                          </div>
-                        </div>
-                      </div>
-                      <div className="row">
-                        <div className="col-12">
-                          <span>{issue.title}</span>
-                        </div>
-                      </div>
-                    </li>
-                  )
-                })
-              }
-            </ul>
-            <div className="card-footer p-1">
-              <div className="row p-1">
-                <div className="col-md-3 text-muted"
-                     data-toggle="collapse" data-target="#counts" style={{cursor: 'pointer'}}
-                >
-                  <span>View More</span>
-                  <i className="fa fa-angle-right ml-1" aria-hidden="true"/>
-                </div>
-                <div className="col-md-9 collapse" id={'counts'}>
-                  <div className="row pt-0">
-                    <div className="col-md-4 text-center">
-                      <img src="https://bugzilla.redhat.com/favicon.ico" style={{height: '16px'}} className={"mr-2"}/>
-                      <a target="blank"
-                         href={this.state.more.bugzilla.link}>Bugzilla ({this.state.more.bugzilla.count})</a>
-                    </div>
-                    <div className="col-md-4 text-center">
-                      <img src="https://github.com/favicon.ico" style={{height: '16px'}} className={"mr-2"}/>
-                      <a target="blank"
-                         href={this.state.more.github.link}>Github ({this.state.more.github.count})</a>
-                    </div>
-                    <div className="col-md-4 text-center">
-                      <img src="https://pagure.io/static/favicon.ico" style={{height: '16px'}} className={"mr-2"}/>
-                      <a target="blank"
-                         href={this.state.more.pagure.link}>Pagure ({this.state.more.pagure.count})</a>
-                    </div>
-                  </div>
-
-                </div>
-              </div>
-            </div>
-          </div>
-        )
-      }
+      content = (
+        <div>
+          <ul className="list-unstyled">
+            {
+              this.state.issues.map((issue) => {
+                return (
+                  <Issue key={issue.service + issue.number} issue={issue} />
+                )
+              })
+            }
+          </ul>
+          <Footer counts={this.state.counts} />
+        </div>
+      )
     }
     return (
       <WidgetChrome
diff --git a/hubs/tests/widgets/test_issues.py b/hubs/tests/widgets/test_issues.py
index cfb52a2..7bc85df 100644
--- a/hubs/tests/widgets/test_issues.py
+++ b/hubs/tests/widgets/test_issues.py
@@ -12,6 +12,9 @@ class IssuesTest(WidgetTest):
         self._add_widget_under_test()
 
     def test_author_should_invalidate_bugzilla(self):
+        self._update_widget_config({
+            "mode": "author",
+        })
         msg = {
             'topic': 'tests.bugzilla.bug.new',
             'msg': {
@@ -23,7 +26,27 @@ class IssuesTest(WidgetTest):
         func = self.widget.module.get_cached_functions()['GetBugzillaBugs']
         self.assertTrue(func(self.widget).should_invalidate(msg))
 
+    def test_author_should_invalidate_github(self):
+        self._update_widget_config({
+            "mode": "author",
+        })
+        msg = {
+            'topic': 'tests.github.issue.opened',
+            'msg': {
+                'issue': {
+                    'user': {
+                        'login': self.widget.hub.config['github_username'],
+                    }
+                },
+            },
+        }
+        func = self.widget.module.get_cached_functions()['GetGithubIssues']
+        self.assertTrue(func(self.widget).should_invalidate(msg))
+
     def test_author_should_invalidate_pagure(self):
+        self._update_widget_config({
+            "mode": "author",
+        })
         msg = {
             'topic': 'tests.pagure.issue.new',
             'msg': {
@@ -50,6 +73,23 @@ class IssuesTest(WidgetTest):
         func = self.widget.module.get_cached_functions()['GetBugzillaBugs']
         self.assertTrue(func(self.widget).should_invalidate(msg))
 
+    def test_assignee_should_invalidate_github(self):
+        self._update_widget_config({
+            "mode": "assignee",
+        })
+        msg = {
+            'topic': 'tests.github.issue.opened',
+            'msg': {
+                'issue': {
+                    'assignee': {
+                        'login': self.widget.hub.config['github_username'],
+                    }
+                },
+            },
+        }
+        func = self.widget.module.get_cached_functions()['GetGithubIssues']
+        self.assertTrue(func(self.widget).should_invalidate(msg))
+
     def test_assignee_should_invalidate_pagure(self):
         self._update_widget_config({
             "mode": "assignee",
diff --git a/hubs/widgets/issues/__init__.py b/hubs/widgets/issues/__init__.py
index 36a9b9e..90118c7 100644
--- a/hubs/widgets/issues/__init__.py
+++ b/hubs/widgets/issues/__init__.py
@@ -13,6 +13,10 @@ class Issues(Widget):
         dict(
             name='mode',
             default='author',
+        ),
+        dict(
+            name='count',
+            default=15,
         )
     ]
     is_react = True
diff --git a/hubs/widgets/issues/functions.py b/hubs/widgets/issues/functions.py
index d033c99..cf19bab 100644
--- a/hubs/widgets/issues/functions.py
+++ b/hubs/widgets/issues/functions.py
@@ -72,10 +72,7 @@ class GetPagureIssues(CachedFunction):
            message['topic'].endswith('pagure.issue.assigned.added') or \
            message['topic'].endswith('pagure.issue.assigned.reset') or \
            message['topic'].endswith('pagure.issue.drop'):
-            if mode == 'author':
-                return message['msg']['user']['name'] == username
-            elif mode == 'assignee':
-                return message['msg']['assignee']['name'] == username
+            return message['msg']['user' if mode == 'author' else 'assignee']['name'] == username
 
     def should_invalidate_on_hub_config_change(self, old_config):
         return old_config['pagure_username'] != self.instance.hub.config['pagure_username']
@@ -104,7 +101,13 @@ class GetGithubIssues(CachedFunction):
         return [res, total_count]
 
     def should_invalidate(self, message):
-        return False
+        mode = self.instance.config['mode']
+        username = self.instance.hub.config['github_username']
+        if message['topic'].endswith('github.issue.opened') or \
+           message['topic'].endswith('github.issue.reopened') or \
+           message['topic'].endswith('github.issue.edited') or \
+           message['topic'].endswith('github.issue.closed'):
+            return message['msg']['issue']['user' if mode == 'author' else 'assignee']['login'] == username
 
     def should_invalidate_on_hub_config_change(self, old_config):
         return old_config['github_username'] != self.instance.hub.config['github_username']
diff --git a/hubs/widgets/issues/views.py b/hubs/widgets/issues/views.py
index aea1c95..e6d1e48 100644
--- a/hubs/widgets/issues/views.py
+++ b/hubs/widgets/issues/views.py
@@ -31,23 +31,35 @@ class DataView(WidgetView):
 
         all_issues = bugzilla + pagure + github
         all_issues.sort(key=lambda x: arrow.get(x['updated_at']), reverse=True)
-        all_issues = all_issues[:min(15, len(all_issues))]
+        all_issues = all_issues[:int(instance.config['count'])]
 
         data = {
             'issues': all_issues,
-            'more': {
+            'counts': {}
+        }
+
+        if bzcnt is not None:
+            data['counts'].update({
                 'bugzilla': {'count': bzcnt,
                              'link': 'https://bugzilla.redhat.com/buglist.cgi?quicksearch={}:{}'
-                                     .format('reporter' if instance.config['mode'] == 'author' else 'assigned_to',
-                                             instance.hub.config['bugzilla_email'])
-                             },
+                                 .format('reporter' if instance.config['mode'] == 'author' else 'assigned_to',
+                                         instance.hub.config['bugzilla_email'])
+                             }
+            })
+
+        if pcnt is not None:
+            data['counts'].update({
                 'pagure': {'count': pcnt,
                            'link': 'https://pagure.io/user/{}/issues'.format(instance.hub.config['pagure_username'])
-                           },
+                           }
+            })
+
+        if ghcnt is not None:
+            data['counts'].update({
                 'github': {'count': ghcnt,
                            'link': 'https://github.com/issues?q=type:issue+state:open+{}:{}'
-                                    .format(instance.config['mode'], instance.hub.config['github_username'])
+                               .format(instance.config['mode'], instance.hub.config['github_username'])
                            }
-            }
-        }
+            })
+
         return dict(status='OK', data=data)

